//+------------------------------------------------------------------+
//|                                                      BBRSI41.mq4 |
//|                                   Copyleft  2010 Zakharov Vadim |
//|                                                   aka Yuritch    |
//+------------------------------------------------------------------+

// !         
//  Basketbull   8.6  !!!

#property  indicator_separate_window
#property indicator_buffers     2
#property indicator_color1      Silver
#property indicator_width1      2
#property indicator_color2      Orange
#property indicator_width2      2
#property indicator_levelcolor  Gray

int TF = 0,period,basket,smooth,price,mode;
extern string  _=" ";
extern int     depth=1440;
int i, j;
double rsi[],rsima1[],rsima2[],delta[],delta1[],tmp,weight_sum,weight,trend_base, deltamax;
static double rsiextr;
string Pairs[];
bool Recalculate=true;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   IndicatorDigits(1);
   IndicatorBuffers(5);

      period=GlobalVariableGet("period");
      smooth=GlobalVariableGet("smooth");
      price= GlobalVariableGet("a_price");
      mode=GlobalVariableGet("mode");
      trend_base=GlobalVariableGet("trend_base");
     
      SetIndexBuffer(0,delta1);
      SetIndexStyle(0,DRAW_LINE);
      SetIndexLabel(0,"delta1");      
      SetIndexBuffer(1,delta);
      SetIndexStyle(1,DRAW_HISTOGRAM,0,2);
      SetIndexLabel(1,"delta");      
      SetIndexBuffer(2,rsima1);
      SetIndexLabel(2,NULL);
      SetIndexStyle(2,DRAW_NONE);       
      SetIndexBuffer(3,rsima2);
      SetIndexLabel(3,NULL);
      SetIndexStyle(3,DRAW_NONE);       
      SetIndexBuffer(4,rsi);
      SetIndexLabel(4,NULL);       
      SetIndexStyle(4,DRAW_NONE);

      ArrayResize(Pairs,basket);
      
      SetIndexEmptyValue(0,EMPTY_VALUE);
      SetIndexEmptyValue(1,EMPTY_VALUE);
      SetIndexEmptyValue(2,EMPTY_VALUE);
      SetIndexEmptyValue(3,EMPTY_VALUE);
      SetIndexEmptyValue(4,EMPTY_VALUE);

      Recalculate=true;
           
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() 
{
   int    limit;
   int counted_bars=IndicatorCounted();
   
   if ( counted_bars > 0 )  limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 ) limit=depth;
   if ( counted_bars < 1 )
      for(int i=1;i<depth+smooth+period;i++) 
         {
         rsi[Bars-i]=0;    
         rsima1[Bars-i]=0;  
         rsima2[Bars-i]=0;    
         delta[Bars-i]=0;  
         delta1[Bars-i]=0;    
         } 
    
   if (GlobalVariableGet("reset") !=0)
      {
       Recalculate=true;
       IndicatorShortName("  ");
       return(0);
      }
   else 
      {
      IndicatorShortName("BBRSI41("+period+","+smooth+","+mode+","+price+")");
      }
             
   if (Recalculate)
      {
      period=GlobalVariableGet("period");
      smooth=GlobalVariableGet("smooth");
      price= GlobalVariableGet("a_price");
      mode=GlobalVariableGet("mode");
      trend_base=GlobalVariableGet("trend_base");
           
      for(i=1;i<depth+smooth+period;i++) 
         {
         rsi[Bars-i]=0;    
         rsima1[Bars-i]=0;  
         rsima2[Bars-i]=0;    
         delta[Bars-i]=0;  
         delta1[Bars-i]=0;    
         }     
      
      SetLevelValue(1,trend_base);
      SetLevelValue(2,-trend_base);
      limit=depth;
      }
      
   i=limit;     
   while(i >=0)  
      {
      rsi[i]=iRSI(Symbol(),TF,period,price,i);
      i--;
      }
   ArraySetAsSeries(rsi,true);
      
   i=limit;
   while(i >=0)  
      {
      rsima1[i]=iMAOnArray(rsi,0,smooth,0,mode,i);
      rsima2[i]=iMAOnArray(rsi,0,MathRound(smooth/2),0,mode,i);
      i--;
      }
       
   i=limit;
   while(i >=0)
      {
      delta[i]=NormalizeDouble(rsima2[i]-rsima1[i],1);
      if ((delta[i]>0 && delta[i]>=delta1[i+1]) || (delta[i]<0 && delta[i]<=delta1[i+1])) 
         {
         delta1[i]=delta[i];
         }
      else delta1[i]=delta1[i+1];
      i--;
      }
      
   if (Recalculate==true) {WindowRedraw();Recalculate=false;}
return(0);
}

